/*

  This file is part of GESTURES.DLL source code, see MAIN.C for
  detailed information.

  Copyright (C) 2000-2001 Pavel Vitis
  pavel.vitis@seznam.cz
  http://lsg.come.to/


  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/****************************************************************************
****************************************************************************/

#include <windows.h>
#include "main.h"
#include "lsapi.h"
#include <string.h>

PSTROKE strokes = NULL;
ACTION def_action;
char *def_notify_snd = NULL, *def_timeout_snd = NULL;

void setAction( ACTION *act, LPSTR buf, LPCTSTR args )
{
	memset(act, '\0', sizeof(ACTION));

	if ( buf == NULL )
		return;
	else
	{
		if ( stricmp(".close", buf) == 0 )
			act->id = ACT_WC_CLOSE;
		else
		if ( stricmp(".minimize", buf) == 0 )
			act->id = ACT_WC_MINIMIZE;
		else
		if ( stricmp(".maximize", buf) == 0 )
			act->id = ACT_WC_MAXIMIZE;
		else
		if ( stricmp(".restore", buf) == 0 )
			act->id = ACT_WC_RESTORE;
		else
		if ( stricmp(".shade", buf) == 0 )
			act->id = ACT_WC_SHADE;
		else
		if ( stricmp(".unshade", buf) == 0 )
			act->id = ACT_WC_UNSHADE;
		else
		if ( stricmp(".next", buf) == 0 )
			act->id = ACT_WC_NEXT;
		else
		if ( stricmp(".prev", buf) == 0 )
			act->id = ACT_WC_PREV;
		else
		if ( stricmp(".sendback", buf) == 0 )
			act->id = ACT_WC_SENDBACK;
		else
		if ( stricmp(".ontop", buf) == 0 )
			act->id = ACT_WC_ONTOP;
		else
		if ( stricmp(".notontop", buf) == 0 )
			act->id = ACT_WC_NOTONTOP;
		else
		if ( stricmp(".move", buf) == 0 )
			act->id = ACT_WC_MOVE;
		else
		if ( stricmp(".resize", buf) == 0 )
			act->id = ACT_WC_RESIZE;
		else
		if ( stricmp(".hlpback", buf) == 0 )
			act->id = ACT_HELP_BACK;
		else
		if ( stricmp(".browseback", buf) == 0 )
			act->id = ACT_BROWSER_BACK;
		else
		if ( stricmp(".browseforward", buf) == 0 )
			act->id = ACT_BROWSER_FORWARD;
		else
		if ( stricmp(".browsereload", buf) == 0 )
			act->id = ACT_BROWSER_RELOAD;
		else
		if ( stricmp(".message", buf) == 0 )
			act->id = ACT_MESSAGE;
		else
		if ( stricmp(".exec", buf) == 0 )
		{
			act->id = ACT_EXECUTE;
			act->parm = strdup(args);
		}
		else
		if ( buf[0] == '!' )
		{
			act->id = ACT_BANG;
			act->parm = strdup(strcat(strcat(buf, " "), args));
			LOGF("BANG: '%s'", act->parm);
		}
	}
}

void freeStrokes( PSTROKE strokelist )
{
	PSTROKE next;

	while ( strokelist )
	{
		next = strokelist->next;
		deleteStroke(strokelist);
		strokelist = next;
	}
}

PSTROKE newStroke(void)
{
	PSTROKE str;

	str = (PSTROKE) malloc( sizeof(STROKE) );
	memset( str, '\0', sizeof(STROKE) );

	str->timeout = def_timeout;
	str->action = def_action;

	return str;
}

PSTROKE addStroke( PSTROKE str )
{
	if ( strokes )
	{
		PSTROKE last;

		last = strokes;
		while ( last->next )
			last = last->next;
		last->next = str;
	}
	else
	{
		strokes = str;
	}

	return str;
}

void deleteStroke( PSTROKE str )
{
	if (str)
	{
		free(str->name);
		free(str->notify_snd);
		free(str->timeout_snd);
		free(str->exclude_win);
		free(str->exclude_mod);
		free(str->sequence);
		free(str->action.parm);
		free(str);
	}
}
